Index: anches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.3/HiveAdministratorClient.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.3/HiveAdministratorClient.cs	(revision 6756)
+++ 	(revision )
@@ -1,40 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Clients.Hive.Administrator {
-  [Item("Hive Administrator", "Hive Administrator")]
-  public class HiveAdministratorClient : Item {
-
-    public HiveAdministratorClient() {
-    }
-
-    protected HiveAdministratorClient(HiveAdministratorClient original, Cloner cloner)
-      : base(original, cloner) {
-      //TODO: clone
-    }
-    public override IDeepCloneable Clone(HeuristicLab.Common.Cloner cloner) {
-      return new HiveAdministratorClient(this, cloner);
-    }
-  }
-}
Index: anches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveExperiment.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveExperiment.cs	(revision 6756)
+++ 	(revision )
@@ -1,87 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.ComponentModel;
-using HeuristicLab.Common;
-
-namespace HeuristicLab.Clients.Hive {
-  public partial class Job : IDeepCloneable, IContent {
-
-    private bool isPrivileged;
-    public bool IsPrivileged {
-      get { return isPrivileged; }
-      set { isPrivileged = value; }
-    }
-
-    #region Constructors and Cloning
-    public Job() {
-      this.ResourceNames = "HEAL";
-      this.DateCreated = DateTime.Now;
-      this.Permission = Permission.Full;
-    }
-
-    protected Job(Job original, Cloner cloner) {
-      cloner.RegisterClonedObject(original, this);
-      this.OwnerUserId = original.OwnerUserId;
-      this.DateCreated = original.DateCreated;
-      this.ResourceNames = original.ResourceNames;
-      this.LastAccessed = original.LastAccessed;
-      this.Name = original.Name;
-      this.Description = original.Description;
-      this.Id = original.Id;
-      this.IsPrivileged = original.IsPrivileged;
-      this.Permission = original.Permission;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Job(this, cloner);
-    }
-    #endregion
-
-    #region Events
-    public event EventHandler StateLogListChanged;
-    private void OnStateLogListChanged() {
-      var handler = StateLogListChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-    #endregion
-
-    protected override void OnPropertyChanged(PropertyChangedEventArgs e) {
-      base.OnPropertyChanged(e);
-      if (e.PropertyName == "Name") {
-        OnToStringChanged();
-      }
-    }
-
-    protected override void RaisePropertyChanged(string propertyName) {
-      if (!(propertyName == "ExecutionTime")
-        && !(propertyName == "JobCount")
-        && !(propertyName == "CalculatingCount")
-        && !(propertyName == "FinishedCount")) {
-        base.RaisePropertyChanged(propertyName);
-      }
-    }
-
-    public override string ToString() {
-      return Name;
-    }
-  }
-}
Index: anches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveExperimentPermission.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveExperimentPermission.cs	(revision 6756)
+++ 	(revision )
@@ -1,65 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.ComponentModel;
-using HeuristicLab.Common;
-
-namespace HeuristicLab.Clients.Hive {
-  public partial class JobPermission : IDeepCloneable, IContent {
-
-    private string grantedUserName;
-    public string GrantedUserName {
-      get { return grantedUserName; }
-      set {
-        if (value != grantedUserName) {
-          grantedUserName = value;
-          RaisePropertyChanged("GrantedUserName");
-        }
-      }
-    }
-
-    #region Constructors and Cloning
-    public JobPermission() {
-      this.Permission = Permission.Read;
-      this.PropertyChanged += new PropertyChangedEventHandler(HiveExperimentPermission_PropertyChanged);
-    }
-
-    protected JobPermission(JobPermission original, Cloner cloner)
-      : base(original, cloner) {
-      this.GrantedByUserId = original.GrantedByUserId;
-      this.GrantedUserId = original.GrantedUserId;
-      this.JobId = original.JobId;
-      this.Permission = original.Permission;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new JobPermission(this, cloner);
-    }
-    #endregion
-
-    private void HiveExperimentPermission_PropertyChanged(object sender, PropertyChangedEventArgs e) {
-      OnToStringChanged();
-    }
-
-    public override string ToString() {
-      return string.Format("{0}: {1}", GrantedUserName, Permission.ToString());
-    }
-  }
-}