Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutView.resx
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutView.resx	(revision 6743)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutView.resx	(revision 6764)
@@ -122,5 +122,5 @@
     <value>
         iVBORw0KGgoAAAANSUhEUgAAAKAAAAC0CAYAAAATiCegAAAABHNCSVQICAgIfAhkiAAAAAFzUkdCAK7O
-        HOkAAAAEZ0FNQQAAsY8L/GEFAAAACXBIWXMAAA3WAAAN1gGQb3mcAAAAGXRFWHRTb2Z0d2FyZQB3d3cu
+        HOkAAAAEZ0FNQQAAsY8L/GEFAAAACXBIWXMAAA3VAAAN1QE91ljxAAAAGXRFWHRTb2Z0d2FyZQB3d3cu
         aW5rc2NhcGUub3Jnm+48GgAAF8tJREFUeF7tXQe0FsUVBhQLKKBiISpixYbYC7FrJFasiT2oMQGPohxL
         JJZgV0xiFI81Go3lxBaxazBibxgPWGMHsfcau+b73pl97lt2/3+/2d1/Zh/DOffwv907c+/c+ebO3JnZ
@@ -229,5 +229,5 @@
   </data>
   <data name="licenseTextBox.Text" xml:space="preserve">
-    <value>HeuristicLab Hive is free software: you can redistribute it and/or modify
+    <value>HeuristicLab is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/JobsView.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/JobsView.Designer.cs	(revision 6743)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/JobsView.Designer.cs	(revision 6764)
@@ -68,8 +68,10 @@
       // 
       this.columnJobId.Text = "Job Id";
+      this.columnJobId.Width = 120;
       // 
       // columnExecutionTime
       // 
       this.columnExecutionTime.Text = "Execution Time";
+      this.columnExecutionTime.Width = 120;
       // 
       // JobsView
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/JobsView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/JobsView.cs	(revision 6743)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/JobsView.cs	(revision 6764)
@@ -70,5 +70,9 @@
           lstJobs.Items.Add(item);
         }
-        lstJobs.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
+        if (e.Value.Jobs.Count == 0) {
+          lstJobs.AutoResizeColumns(ColumnHeaderAutoResizeStyle.None);
+        } else {
+          lstJobs.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
+        }
       }
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.Designer.cs	(revision 6743)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.Designer.cs	(revision 6764)
@@ -185,4 +185,5 @@
       this.notifyIcon.Text = "HeuristicLab Hive Slave";
       this.notifyIcon.Visible = true;
+      this.notifyIcon.BalloonTipClicked += new System.EventHandler(this.notifyIcon_BalloonTipClicked);
       this.notifyIcon.DoubleClick += new System.EventHandler(this.notifyIcon_DoubleClick);
       // 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.cs	(revision 6743)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.cs	(revision 6764)
@@ -96,10 +96,10 @@
     }
 
+    private void homepageToolStripMenuItem_Click(object sender, EventArgs e) {
+      System.Diagnostics.Process.Start("http://dev.heuristiclab.com");
+    }
+
     private void notifyIcon_BalloonTipClicked(object sender, EventArgs e) {
       OnVisibilitySwitched();
-    }
-
-    private void homepageToolStripMenuItem_Click(object sender, EventArgs e) {
-      System.Diagnostics.Process.Start("http://dev.heuristiclab.com");
     }
 